--- drm_bufs.c.orig	2005-03-29 14:51:51.000000000 -0800
+++ drm_bufs.c	2005-03-29 14:53:12.000000000 -0800
@@ -1163,7 +1163,7 @@
 	drm_buf_map_t __user *argp = (void __user *)arg;
 	int retcode = 0;
 	const int zero = 0;
-	unsigned long virtual;
+	unsigned long virt_map;
 	unsigned long address;
 	drm_buf_map_t request;
 	int i;
@@ -1199,7 +1199,7 @@
 #else
 			down_write( &current->mm->mmap_sem );
 #endif
-			virtual = do_mmap( filp, 0, map->size,
+			virt_map = do_mmap( filp, 0, map->size,
 					   PROT_READ | PROT_WRITE,
 					   MAP_SHARED,
 					   (unsigned long)map->offset );
@@ -1214,7 +1214,7 @@
 #else
 			down_write( &current->mm->mmap_sem );
 #endif
-			virtual = do_mmap( filp, 0, dma->byte_count,
+			virt_map = do_mmap( filp, 0, dma->byte_count,
 					   PROT_READ | PROT_WRITE,
 					   MAP_SHARED, 0 );
 #if LINUX_VERSION_CODE <= 0x020402
@@ -1223,12 +1223,12 @@
 			up_write( &current->mm->mmap_sem );
 #endif
 		}
-		if ( virtual > -1024UL ) {
+		if ( virt_map > -1024UL ) {
 			/* Real error */
-			retcode = (signed long)virtual;
+			retcode = (signed long)virt_map;
 			goto done;
 		}
-		request.virtual = (void __user *)virtual;
+		request.virt_map = (void __user *)virt_map;
 
 		for ( i = 0 ; i < dma->buf_count ; i++ ) {
 			if ( copy_to_user( &request.list[i].idx,
@@ -1249,7 +1249,7 @@
 				retcode = -EFAULT;
 				goto done;
 			}
-			address = virtual + dma->buflist[i]->offset; /* *** */
+			address = virt_map + dma->buflist[i]->offset; /* *** */
 			if ( copy_to_user( &request.list[i].address,
 					   &address,
 					   sizeof(address) ) ) {
